@REM ###==============================================================================
@REM ### @brief  gss4p update batch
@REM ### @author JL
@REM ### @copyright Copyright(C) 2016 Good Mind Industries.,Co Ltd All rights reserved.
@REM ### @par History:
@REM ### 	Date - Author - Version - Comment
@REM ### 	29 Mar 2016 - JL - v1.0 - Created
@REM ### 	31 Mar 2016 - JL - v1.1 - Use Tftp32 instead, xp, loop
@REM ### 	01 Apr 2016 - JL - v1.2 - integrated SSDPSRV service stop into ssdp routine
@REM ### 	06 Jul 2017 - JL - v1.3 - fixed some directory script for tftp32
@REM ### 	24 Jul 2017 - JL - v1.4 - set parameteric inputs
@REM ### 	04 Aug 2017 - JL - v1.5 - set default fw bin size
@REM ###==============================================================================

@echo off

@REM ########################################
@REM ### default variables
@REM ########################################
SET FWBIN=gss4pui_uImage_v3_1_18.bin
SET FWBINSIZE=7091766
SET SKIP_IP_DETECT=0
SET COMBOINDEX=
SET ROOTPASS=SELFSAT

@REM ########################################
@REM ### parametric variables
@REM ### 
@REM ### <bat> -if <combo index> -pass <root pass> -ip <local ip> <server ip>
@REM ########################################

:paramloop
IF NOT "%1"=="" (
@REM ;;; echo .Parameter Switch1 {%1}
@REM ;;; echo .Parameter Switch2 {%2}
    IF "%1"=="-help" (    	
        GOTO :usage   
    )
    IF "%1"=="--help" (    	
        GOTO :usage   
    )
    IF "%1"=="-h" (    	
        GOTO :usage   
    )
    IF "%1"=="-if" (    		
    		IF [%2] == [] GOTO :usage                
        SET COMBOINDEX=%2
        SHIFT
    )
    IF "%1"=="-pass" (  
        IF [%2] == [] GOTO :usage       
        SET ROOTPASS=%2
        SHIFT   
    )
    IF "%1"=="-ip" (
        IF [%2] == [] GOTO :usage
        IF [%3] == [] GOTO :usage
        SET IP_LOCAL=%2
        SET IP_SERVER=%3
        SET SKIP_IP_DETECT=1
        SHIFT & SHIFT
    )

		SHIFT
		
@REM ;;; echo .Parameter Switch now1 {%1}
@REM ;;; echo .Parameter Switch now2 {%2}
    
    GOTO :paramloop
)

@REM ;;; set ARGC=0
@REM ;;; for %%x in (%*) do Set /A ARGC+=1
@REM ;;;
@REM ;;; echo Number of Arguments: %ARGC%
@REM ;;;
@REM ;;; IF (%ARGC% GTR 0) AND (%ARGC% GTR 0)

@REM ;;;echo Press any key to continue...
@REM ;;;pause
:begin_execution

@REM ########################################
@REM ### enviornment variables
@REM ########################################
set DEBUGMODE=0
set CURDIR=%cd%
set LOCALIPFILE="%cd%"\IP\local.txt
set SERVERIPFILE="%cd%"\IP\server.txt
set MULTIIFFILE="%cd%"\IP\multiif.txt
set LOGDIR="%cd%\log"
set IPFINDEXE="%cd%"\scripts\ssdp_9.exe
set DIALOGEXE="%cd%"\teraterm\gss4p_dialog3.exe
set loopp=0
set maxloopp=10
set rescanwait=10
SET FWBINFULL="%CURDIR%"\Tftpd32\%FWBIN%

IF NOT EXIST %FWBINFULL% (
echo .
echo ERROR: Firmware File [%FWBINFULL%] does NOT exist!
echo .
goto:eof
)

@REM ### calculate firmware size
@REM ;;;FOR %%A IN (%FWBINFULL%) DO set FWBINSIZE=%%~zA

echo Firmware filesize: %FWBINSIZE% bytes

@REM ########################################
@REM ### START: display parameteric variables
@REM ########################################
echo Combo Index: [%COMBOINDEX%]
echo Root pass: [%ROOTPASS%]
echo Firmware Binary: [%FWBIN%]

@REM ###
@REM ### ---> skipping to start tftp server if we don't need to detect IP
@REM ###

IF %SKIP_IP_DETECT% NEQ 0 GOTO begin_tftp


echo Obtaing IP Addresses:
IF %DEBUGMODE% EQU 0 GOTO stop_upnp
Press any key to continue...
pause

:stop_upnp
@REM ###
@REM ### stop the UPnP services
@REM ### echo "Stopping UPnP services"
@REM ### sc stop upnphost
@REM ### ping 127.0.0.1 -n 3 > nul
@REM ### sc stop SSDPSRV
@REM ### ping 127.0.0.1 -n 3 > nul
@REM ###

mkdir "%cd%"\IP
mkdir %LOGDIR%

@REM ### obtain SAT>IP server IPs

:rescanip
echo "Obtainging Satip server IP"
del IP\*.txt
%IPFINDEXE% IP\local.txt IP\server.txt IP\multiif.txt %COMBOINDEX%

@REM ### check multi if first
if exist %MULTIIFFILE% (
    @REM ### file exists, indicating multi if, exit
    %DIALOGEXE% 3
    EXIT /B 1
)

@REM ### check on local host ip and server ip

if exist %LOCALIPFILE% (
    @REM ### file exists
) else (
    @REM ### file doesn't exist
    echo "Cannot find local IP: " %loopp%

    set /a loopp=loopp+1
	  if not "%loopp%"=="%maxloopp%" (
        @REM ### sleep for a while
		    ping 127.0.0.1 -n %rescanwait% > nul
		    goto rescanip
		)

    %DIALOGEXE% 4
    @REM ### echo "Press any key to continue"
    @REM ### pause
    EXIT /B 1
)

if exist %SERVERIPFILE% (
    @REM ### file exists
) else (
    @REM ### file doesn't exist
    echo "Cannot find SATIP server IP: " %loopp%

    set /a loopp=loopp+1
	  if not "%loopp%"=="%maxloopp%" (
        @REM ### sleep for a while
		    ping 127.0.0.1 -n %rescanwait% > nul
		    goto rescanip
		)

    %DIALOGEXE% 5
    @REM ### echo "Press any key to continue"
    @REM ### pause
    EXIT /B 1
)

echo "Local IP file: " %LOCALIPFILE%
set /p IP_LOCAL=<%LOCALIPFILE%
echo "Local IP: " %IP_LOCAL%

echo "Server IP file: " %SERVERIPFILE%
set /p IP_SERVER=<%SERVERIPFILE%
echo "Server IP: " %IP_SERVER%


:begin_tftp

echo "Executing TFTP server..."
@REM ### start OpenTFTPServer\OpenTFTPServerMT.exe -v
@REM ### kill any previously ran tftp servers
taskkill /F /IM tftpd32.exe /T
@REM ### sleep 1
@REM ### ping 127.0.0.1 -n 2 > nul
cd "%CURDIR%"\Tftpd32
start tftpd32.exe /MIN

@REM ### sleep 1
@REM ### ping 127.0.0.1 -n 2 > nul
echo "Executing SSH script..."
cd "%CURDIR%"\teraterm
echo Begin updating firmware
echo Local IP: %IP_LOCAL%
echo Server IP: %IP_SERVER%
echo Log Directory: %LOGDIR%
echo Firmware: %FWBIN%
echo Firmware size: %FWBINSIZE% bytes
echo Root password: [%ROOTPASS%]

IF %DEBUGMODE% EQU 0 GOTO start_upd_scrpt
echo Press any key to continue...
pause

:start_upd_scrpt
ttpmacro.exe ..\scripts\sshswupd.ttl %IP_LOCAL% %IP_SERVER% %LOGDIR% %FWBIN% %FWBINSIZE% %ROOTPASS%

echo "Kill the TFTP server..."
@REM ### taskkill /F /IM OpenTFTPServerMT.exe /T
taskkill /F /IM tftpd32.exe /T

cd "%CURDIR%"
@REM ### echo "Finish Press any key to continue"
@REM ### pause

goto:eof

@REM ########################################
@REM ### EOF
@REM ########################################


@REM ########################################
@REM ### Function
@REM ########################################
:usage
echo %0 -if [combo index] -pass [root pass] -ip [local ip] [server ip]
echo    -if [combo index] : interface combo index
echo    -pass [root pass] : root password for terminal access
echo    -ip [local ip] [server ip] : local IP and server IP addresses
echo Press any key to continue...
pause
goto:eof
